//======================================================
//ftHg萔`
//======================================================

/** @var	float	Pi	~ */
const float Pi = 3.1415926535;


//======================================================
//ftHg֐`
//======================================================

//x@烉WAiʓx@jɕϊ
function radian(float degree)
{
	return	degree*Pi/180; 
}

//x@sin
function sin_deg(float degree)
{
	return	sin(radian(degree)); 
}

//x@cos
function cos_deg(float degree)
{
	return	cos(radian(degree)); 
}


function cos_azimuth(int label_A, int label_B, float rot2_p, float rot2_v)
{

	float R = get_length(label_A, label_B);

	float rot_p, rot_v, rot_b;	
	float XA, YA, ZA;	
	float XB, YB, ZB;	

	get_rot_abs(label_A, rot_p, rot_v, rot_b);
	get_pos(label_A, XA, YA, ZA);			//W擾
	get_pos(label_B, XB, YB, ZB);			//W擾

	int x = 0; // zY0X^[g
	int y = 1;
	int z = 2;

	float vec1[3]; // zvf3mۂȂAY0`2܂
	vec1[x]= XB-XA;
	vec1[y]= YB-YA;
	vec1[z]= ZB-ZA;
	float vec2[3];
	vec2[x]= 0.0;
	vec2[y]= 0.0;
	vec2[z]= 1.0;

		 //  s
	float mat[5][3][3]; // Y0X^[g
//	|  1    0      0   |
//1	|  0 cosp  sinp|
//	|  0 -sinp cosp|

	mat[0][0][0] = 1.0;
	mat[0][0][1] = 0.0;
	mat[0][0][2] = 0.0;
	mat[0][1][0] = 0.0;
	mat[0][1][1] = cos_deg(rot2_p);
	mat[0][1][2] = sin_deg(rot2_p);
	mat[0][2][0] = 0.0;
	mat[0][2][1] = -sin_deg(rot2_p);
	mat[0][2][2] = cos_deg(rot2_p);

//	| cosv  0 sinv|
//2 	|   0	  1   0   |
//	| -sinv 0 cosv|

	mat[1][0][0] = cos_deg(rot2_v);
	mat[1][0][1] = 0.0;
	mat[1][0][2] = sin_deg(rot2_v);
	mat[1][1][0] = 0.0;
	mat[1][1][1] = 1.0;
	mat[1][1][2] = 0.0;
	mat[1][2][0] = -sin_deg(rot2_v);
	mat[1][2][1] = 0.0;
	mat[1][2][2] = cos_deg(rot2_v);

//	|cosb -sinb  0 |
//3	|sinb  cosb  0 |
//	|  0       0     1 |

	mat[2][0][0] = cos_deg(rot_b);
	mat[2][0][1] = -sin_deg(rot_b);
	mat[2][0][2] = 0.0;
	mat[2][1][0] = sin_deg(rot_b);
	mat[2][1][1] = cos_deg(rot_b);
	mat[2][1][2] = 0.0;
	mat[2][2][0] = 0.0;
	mat[2][2][1] = 0.0;
	mat[2][2][2] = 1.0;
       
//	|  1    0      0   |
//4	|  0 cosp  sinp|
//	|  0 -sinp cosp|

	mat[3][0][0] = 1.0;
	mat[3][0][1] = 0.0;
	mat[3][0][2] = 0.0;
	mat[3][1][0] = 0.0;
	mat[3][1][1] = cos_deg(rot_p);
	mat[3][1][2] = sin_deg(rot_p);
	mat[3][2][0] = 0.0;
	mat[3][2][1] = -sin_deg(rot_p);
	mat[3][2][2] = cos_deg(rot_p);
       
//	| cosv  0 sinv|
//5	|   0	  1   0   |
//	| -sinv 0 cosv|

	mat[4][0][0] = cos_deg(rot_v);
	mat[4][0][1] = 0.0;
	mat[4][0][2] = sin_deg(rot_v);
	mat[4][1][0] = 0.0;
	mat[4][1][1] = 1.0;
	mat[4][1][2] = 0.0;
	mat[4][2][0] = -sin_deg(rot_v);
	mat[1][2][1] = 0.0;
	mat[4][2][2] = cos_deg(rot_v);
       
	float vec3[3]; // for̊OŐ錾
	for(n=0;n<=4;n++){
		vec3[x] = 0.0; // for̒ŖI0.0ŏ
		vec3[y] = 0.0;
		vec3[z] = 0.0;
		// sƃxNg̐ςvZ
		for(i=0;i<=2;i++){
			for(j=0;j<=2;j++){
				vec3[i] += mat[n][i][j]*vec2[j];
			}
		}
		vec2[x] = vec3[x]; // ̎Ŏgp邽߂vec2ɑ
		vec2[y] = vec3[y];
		vec2[z] = vec3[z];
	}
	
	float cos_a; // RSEł͖Iɐ錾ȂĂvÔ
	cos_a = (vec1[x]*vec2[x]+vec1[y]*vec2[y]+vec1[z]*vec2[z]) / R;
	
	return cos_a;
}


function cos_azimuth_X_Z(int label_A, int label_B, int rot_p, int rot_v)
{

	float angle_p, angle_v, angle_b;	
	float XA, YA, ZA;	
	float XB, YB, ZB;	

	get_rot_abs(label_A, angle_p, angle_v, angle_b);
	get_pos(label_A, XA, YA, ZA);			//W擾
	get_pos(label_B, XB, YB, ZB);			//W擾
	float R =  pow(pow((XB-XA), 2)+pow((ZB-ZA), 2), 1/2);
	
	cos_a = (((XB-XA)*sin_deg(angle_v+rot_v))+((ZB-ZA)*cos_deg(angle_v+rot_v))) / R;

	return cos_a;
}
 




function cos_azimuth_low(int label_A, int label_B, int rot_p, int rot_v)
{

	float R = get_length(label_A, label_B);

	float angle_p, angle_v, angle_b;	
	float XA, YA, ZA;	
	float XB, YB, ZB;	

	get_rot_abs(label_A, angle_p, angle_v, angle_b);
	get_pos(label_A, XA, YA, ZA);			//W擾
	get_pos(label_B, XB, YB, ZB);			//W擾
	
	cos_a = (((XB-XA)*cos_deg(angle_p+rot_p)*sin_deg(angle_v+rot_v))+((YB-YA)*sin_deg(angle_p+rot_p))+((ZB-ZA)*cos_deg(angle_p+rot_p)*cos_deg(angle_v+rot_v))) / R;

	return cos_a;
}
